//+------------------------------------------------------------------+
//|                                      PerceptronWarrior-T01D1.mq4 |
//|                          Copyright  2008, HomeSoft-Tartan Corp. |
//|                                             spiky@home.eltel.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, HomeSoft-Tartan Corp."
#property link      "http://www.fxexperts.ru"
//      =D1 EURUSD
//===================================================================
extern int     x1         = 74; // 
extern int     x2         = 63;                        
extern int     x3         = 61;                       
extern int     x4         = 39;  
extern double  porog      = 0.65;//     
extern int     nBar       = 10;   //     
//--------------------------------------------------------------------------------------
extern double   StopLoss  = 1000;
extern double TakeProfit  = 280;
extern double       stop  = 2600;
extern double       risk  = 0.2; 
extern double       mdel  = 60;
extern double       cdel  = 15;
extern int          Magic = 2008;
extern int          kmb   = 4; 
extern int          info  = 1;
//==============================================================================================
// 69695.67	67	2.32 1040.23 21057.00 30.96% x1=74 x2=63 x3=61 x4=39 porog=0.65 nBar=10 info=0 	
// TakeProfit=280	stop=2600 risk=0.2 mdel=60	cdel=15 kmb=4 StopLoss=1000 Magic=25 -  - D1 EURUSD  MQ  01.01  29.09.2008
//==============================================================================================
double sum,fmarg,ssum,bsum,mlot,rptwo,rpone,rpnul,kls,opn,top,MaxH,MinL,MaxOrd,crat,pros,ppros;
int    cnt,k,s,b,bsig,ssig,pl,trend,tt,tiket,spl,bpl,ks,kb,kd,mBar;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  MaxH=High[0];MinL=Low[0];
for (cnt=0;cnt<=kmb*mBar;cnt++)
 {  
 if (MaxH<High[cnt]) MaxH=High[cnt];
 if (MinL>Low[cnt])  MinL=Low[cnt];
 }
     crat=5000;
     MaxOrd=3;
     mBar=300;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----


 if (Minute()<=30) k=0;
 if (Hour()==0) top=NormalizeDouble(Open[0],4);
 if (Minute()>=55 && k==0) 
  {  k=1;
     kls=NormalizeDouble(Close[0],4);
  }    
 if (s+b==0)
  { 
     fmarg=NormalizeDouble(AccountFreeMargin(),0);       
      mlot=NormalizeDouble((fmarg/crat),1);    
  }   
 if (mlot>5) mlot=5; 
 if (mlot<0.1) {if (!IsTesting()) Print(" -  !      !");return(0);}  

     s=0;b=0;ssum=0;bsum=0;sum=0;   
for (cnt=OrdersTotal();cnt>=0;cnt--)
  {
     OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
 if (OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
  {  
     s=s+1;ssum=ssum+OrderProfit()+OrderSwap(); 
  } 
 if (OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)  
  {
     b=b+1;bsum=bsum+OrderProfit()+OrderSwap(); 
  }   
  } 
     ssum=MathRound(ssum); 
     bsum=MathRound(bsum);
     sum=ssum+bsum;      
     
 if (sum<0 && sum<pros) pros=sum;
     ppros=MathAbs(NormalizeDouble(((pros/AccountBalance())*100),1));    
     
 if (s+b==0) pl=0;    
 if (s==0) spl=0;
 if (b==0) bpl=0; 
 if (sum<-AccountBalance()*risk) pl=1;
 if (s==b && sum!=0) pl=1;
 if (sum>stop)  pl=1;  
 if (ssum>stop) spl=1;
 if (bsum>stop) bpl=1;     
        
 if (pl==1 || spl==1 || bpl==1)
  {  
for (cnt=OrdersTotal();cnt>=0 ;cnt--)
  {
     OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
 if (OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic && (pl==1 || spl==1))
  {  RefreshRates();             
     OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); 
     Sleep(10000);
     return(0);
  } 
 if (OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic && (pl==1 || bpl==1))
  {  RefreshRates();    
     OrderClose(OrderTicket(),OrderLots(),Bid,3,Red); 
     Sleep(10000);
     return(0);
  }
  }
  }                 
     bsig=0;ssig=0;      
           
 if (Minute()>55)  
  { 
     ssig=iCustom(NULL,1440,"TradeSignal-T02D1Exp",x1,x2,x3,x4,porog,cdel,nBar,0,0);
     bsig=iCustom(NULL,1440,"TradeSignal-T02D1Exp",x1,x2,x3,x4,porog,cdel,nBar,1,0);
 
     MaxH=High[0];MinL=Low[0];
for (cnt=1;cnt<=kmb*mBar;cnt++)
 {
 if (MaxH<High[cnt]) MaxH=High[cnt];
 if (MinL>Low[cnt])  MinL=Low[cnt];
 } 
  } 
 
 if (info==1 && DayOfWeek()!=5)
  { 
     Comment("\n","  Orders=",s+b,"  Mlot=",mlot,"  Risk=",-MathRound(AccountBalance()*risk),
                  "  PPRos=",ppros,"%","  MinMarg=",MathRound(risk*crat),"  FreeMargin=",fmarg,"  Profit=",sum);  
  }  
 if (DayOfWeek()==5) 
  {
     Comment("\n","   ,     .");Sleep(600000);return(0);
  }
    
 if (fmarg>=risk*crat && tt!=Time[0] && s+b<MaxOrd)
  {
 if (bsig==1 && b<(MaxOrd-1))
  {
     RefreshRates();  
 if (ssum<0 && ssum<bsum && b>0) mlot=mlot*s; if (mlot>5) mlot=5;  
     tiket=OrderSend(Symbol(),OP_BUY,mlot,Ask,5,Ask-StopLoss*Point,Ask+TakeProfit*Point,"StepByStep",Magic,0,Red);
 if (tiket>0)
  {
 if (OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES))
  {
     tt=Time[0];PlaySound("Ku_ku.wav");Sleep(10000);return(0);  
  }
  }
 else
  {
     Print("OpenLong(),  : ",GetLastError());return(-1);  
  }
  }
    
 if (ssig==1 && s<(MaxOrd-1))
  {
     RefreshRates(); 
 if (bsum<0 && bsum<ssum && s>0) mlot=mlot*b;if (mlot>5) mlot=5;  
     tiket=OrderSend(Symbol(),OP_SELL,mlot,Bid,5,Bid+StopLoss*Point,Bid-TakeProfit*Point,"StepByStep",Magic,0,Red);
 if (tiket>0)
  {
 if (OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES))
  {
     tt=Time[0];PlaySound("Ku_ku.wav");Sleep(10000);return(0);
  }
  }
  else
  {
    Print("OpenShort(),  : ",GetLastError());return(-1);
  }           
  }  
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+