//+------------------------------------------------------------------+
//|                                               2BarSignal-T01.mq4 |
//|                          Copyright  2007, HomeSoft-Tartan Corp. |
//|                                             spiky@home.eltel.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, HomeSoft-Tartan Corp."
#property link      "spiky@home.eltel.net"
//      D1    
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Gold
#property indicator_color2 Lime
#property indicator_width1 1
#property indicator_width2 1
//===================================================================
extern int     x1         = 65; // 
extern int     x2         = 65;                        
extern int     x3         = 69;                       
extern int     x4         = 26;  
extern double  porog      = 0.5;//     
extern double  del        = 30; //       
extern int     mBar       = 5; //     
//===================================================================
// x1=65,x2=65,x3=69,x4=26,porog=0.5 -   EURUSD D1 (26.09.2008)
//===================================================================
double UpBuff[],DnBuff[];
int cnt,k;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,DnBuff);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(0,242); 
  
   SetIndexBuffer(1,UpBuff);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(1,241);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
  if (k>0 && Hour()==0 && Minute()<5) k=0;  
  if (perceptron()<-porog && ((Close[0]-Open[0])/Point)>del && Close[1]<Open[1]) UpBuff[0]=Low[cnt]-50*Point; else UpBuff[0]=0;
  if (perceptron()>porog  && ((Close[0]-Open[0])/Point)<-del && Close[1]>Open[1])DnBuff[0]=High[cnt]+50*Point;else DnBuff[0]=0; 
//----
   return(0);
  }
//+------------------------------------------------------------------+
double perceptron() 
    {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;
   
   double a1 = iCustom(NULL, 0, "BarsStepBuy",25,2,mBar,0,0); 
   double a2 = iCustom(NULL, 0, "BarsStepBuy",25,2,mBar,0,1); 
   double a3 = iCustom(NULL, 0, "BarsStepSell",25,2,mBar,0,0);
   double a4 = iCustom(NULL, 0, "BarsStepSell",25,2,mBar,0,1); 
   
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 );
   }
     