//+------------------------------------------------------------------+
//|                                                  BarsStepExp.mq4 |
//|                          Copyright  2007, HomeSoft-Tartan Corp. |
//|                                             spiky@home.eltel.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, HomeSoft-Tartan Corp."
#property link      "spiky@home.eltel.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Lime
#property indicator_width1 3
#property indicator_maximum 1
#property indicator_minimum -1

extern double del=25;
extern int step=2;
extern int mBar=300;

double ExtMapBuff[];
int    ks,kb,kd,cnt,shift; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, ExtMapBuff);
   SetIndexEmptyValue(0,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----  
for (shift=mBar;shift>=0;shift--)
  {  
     kb=0;ks=0;kd=0;
for (cnt=shift+1;cnt<=shift+step;cnt++)
  {  
 if (Close[cnt]<Open[cnt])  ks=ks+1;
 if (Close[cnt]==Open[cnt]) kd=kd+1;
  }  
 if (ks+kd==step && kd<=1 && Close[shift]>Open[shift]) ExtMapBuff[shift]=-1.0;else ExtMapBuff[shift]=-0.3; 
 if (ExtMapBuff[shift+1]==-1 && ExtMapBuff[shift]==-0.3 && Close[shift]>Open[shift]) ExtMapBuff[shift]=-1;
  }        
//----
   return(0);
  }
//+------------------------------------------------------------------+